# Change Log for pseuCo to CCS compiler

## 2.2.0 - 2024-03-28

### Changed
- Upgraded @pseuco/lang and @pseuco/static-semantics to the latest version.

## 2.1.0 - 2024-03-25

### Added
- CCS comments to make the compile result better readable.

### Changed
- Removed constructor processes for global variables, because initialisation is deferred (see 2.0.1).

## 2.0.1 - 2024-03-22

### Fixed
- Global variable initialisations and the main agent could run in parallel, leading to undesired behaviour (see https://dgit.cs.uni-saarland.de/pseuco/pseuco-ccs-compiler/-/issues/5).
- Continue statement ins do loops were skipping the predicate check (see https://dgit.cs.uni-saarland.de/pseuco/pseuco-ccs-compiler/-/issues/4)

## 2.0.0 - 2024-03-21

### Changed
- Major change: @pseuco/lang, @pseuco/static-semantics, and @pseuco/ccs-interpreter are now peer dependencies instead of a regular dependencies. Users of this package must add @pseuco/lang, @pseuco/static-semantics, and @pseuco/ccs-interpreter also as peer dependencies.

## 1.0.0 - 2024-03-07

### Changed
- Re-implementation in TypeScript
- Adapted to select-cases' new syntactic restrictions

### Fixed
- Several smaller bugs

## 0.8.12 - 2021-01-11

### Fixed

- In the `when` guard of the array index out of bounds check the size of the array was represented as a string. E.g., the condition was `when (index>="5"||index<0)` instead of `when (index>=5||index<0)`.

## 0.8.11 - 2021-01-26

### Added

- Support for `assert` (beta).

## 0.8.10 - 2020-06-09

### Fixed

- Send expressions with unbuffered channels could not be used as RHS expression of assignments. The container holding the sent value was not protected during transition to the followup process.

## 0.8.9 - 2019-05-31

### Fixed

- Struct and Monitor constructors executed initialization operations concurrently to the agent constructing the object

## 0.8.8 - 2019-05-16

### Changed

- Reduced internal interleavings caused by sharing free "pointers" among array constructors of different capacities
- Reduced internal interleavings caused by sharing free "Pointers" among buffered channel constructors of different capacities

## 0.8.7 - 2019-05-15

### Added

- This change log file
- New build mode "dev-build", which is compatible with using "npm link" in packages requiring this package

### Fixed

- Error message when package is installed within another package

## 0.8.6 - 2019-05-15

### Added

- Test cases (not passing yet)

### Fixed

- Arrays of structs could not be initialised

