import * as PC from "@pseuco/lang";
import { PCCCompiler } from "./PCCCompiler.js";
import { PCCContainer } from "./PCCContainer.js";
import { CasePreparationData } from "./PCCCompileStatementsVisitor.js";
export declare class PCCCompileExpressionsVisitor extends PC.AbstractVisitor<PCCContainer | null> {
    readonly compiler: PCCCompiler;
    readonly compilingNodes: Array<PC.Node>;
    constructor(compiler: PCCCompiler, compilingNodes: Array<PC.Node>);
    compileNode(node: PC.Expression | PC.AssignDestination, context?: unknown): PCCContainer | null;
    visitStartExpression(node: PC.StartExpression): PCCContainer | null;
    private compileStart;
    visitAssignExpression(node: PC.AssignExpression, context: CasePreparationData): PCCContainer | null;
    private assignContainerToAssignDestination;
    private getValueOfArrayAtIndexOfAssignDestination;
    private setValueOfArrayAtIndexOfAssignDestination;
    visitAssignDestination(node: PC.AssignDestination): PCCContainer | null;
    visitSendExpression(node: PC.SendExpression, context?: CasePreparationData): PCCContainer | null;
    visitReceiveExpression(node: PC.ReceiveExpression, context?: CasePreparationData): PCCContainer | null;
    visitConditionalExpression(node: PC.ConditionalExpression, context?: unknown): PCCContainer | null;
    private visitSimpleExpression;
    visitOrExpression(node: PC.OrExpression, context?: unknown): PCCContainer | null;
    visitAndExpression(node: PC.AndExpression, context?: unknown): PCCContainer | null;
    visitEqualityExpression(node: PC.EqualityExpression, context?: unknown): PCCContainer | null;
    visitRelationalExpression(node: PC.RelationalExpression, context?: unknown): PCCContainer | null;
    visitAdditiveExpression(node: PC.AdditiveExpression, context?: unknown): PCCContainer | null;
    visitMultiplicativeExpression(node: PC.MultiplicativeExpression, context?: unknown): PCCContainer | null;
    visitUnaryExpression(node: PC.UnaryExpression, context?: unknown): PCCContainer | null;
    visitPostfixExpression(node: PC.PostfixExpression, context?: unknown): PCCContainer | null;
    private compileProcedureCall;
    visitProcedureCall(node: PC.ProcedureCall, context?: unknown): PCCContainer | null;
    visitClassCall(node: PC.ClassCall, context?: unknown): PCCContainer | null;
    visitArrayExpression(node: PC.ArrayExpression, context?: unknown): PCCContainer | null;
    visitLiteralExpression(node: PC.LiteralExpression, context?: unknown): PCCContainer | null;
    visitIdentifierExpression(node: PC.IdentifierExpression, context?: unknown): PCCContainer | null;
    visitProgram(node: PC.Program, context?: unknown): PCCContainer | null;
    visitMainAgent(node: PC.MainAgent, context?: unknown): PCCContainer | null;
    visitProcedureDeclaration(node: PC.ProcedureDeclaration, context?: unknown): PCCContainer | null;
    visitProcedureParameter(node: PC.ProcedureParameter, context?: unknown): PCCContainer | null;
    visitMonitor(node: PC.Monitor, context?: unknown): PCCContainer | null;
    visitStruct(node: PC.Struct, context?: unknown): PCCContainer | null;
    visitConditionDeclaration(node: PC.ConditionDeclaration, context?: unknown): PCCContainer | null;
    visitVariableDeclarations(node: PC.VariableDeclarations, context?: unknown): PCCContainer | null;
    visitVariableDeclarator(node: PC.VariableDeclarator, context?: unknown): PCCContainer | null;
    visitVariableInitializer(node: PC.VariableInitializer, context?: unknown): PCCContainer | null;
    visitArrayTypeNode(node: PC.ArrayTypeNode, context?: unknown): PCCContainer | null;
    visitSimpleTypeNode(node: PC.SimpleTypeNode, context?: unknown): PCCContainer | null;
    visitChannelTypeNode(node: PC.ChannelTypeNode, context?: unknown): PCCContainer | null;
    visitClassTypeNode(node: PC.ClassTypeNode, context?: unknown): PCCContainer | null;
    visitStatementWrapper(node: PC.StatementWrapper, context?: unknown): PCCContainer | null;
    visitBreakStatement(node: PC.BreakStatement, context?: unknown): PCCContainer | null;
    visitContinueStatement(node: PC.ContinueStatement, context?: unknown): PCCContainer | null;
    visitStatementBlock(node: PC.StatementBlock, context?: unknown): PCCContainer | null;
    visitStatementExpression(node: PC.StatementExpression, context?: unknown): PCCContainer | null;
    visitSelectStatement(node: PC.SelectStatement, context?: unknown): PCCContainer | null;
    visitCase(node: PC.Case, context?: unknown): PCCContainer | null;
    visitConditionStatement(node: PC.ConditionStatement, context?: unknown): PCCContainer | null;
    visitIfStatement(node: PC.IfStatement, context?: unknown): PCCContainer | null;
    visitWhileStatement(node: PC.WhileStatement, context?: unknown): PCCContainer | null;
    visitDoStatement(node: PC.DoStatement, context?: unknown): PCCContainer | null;
    visitForStatement(node: PC.ForStatement, context?: unknown): PCCContainer | null;
    visitForInit(node: PC.ForInit, context?: unknown): PCCContainer | null;
    visitReturnStatement(node: PC.ReturnStatement, context?: unknown): PCCContainer | null;
    visitPrimitiveStatement(node: PC.PrimitiveStatement, context?: unknown): PCCContainer | null;
    visitPrintStatement(node: PC.PrintStatement, context?: unknown): PCCContainer | null;
}
