import * as PC from "@pseuco/lang";
import { PCCProgramController } from "./PCCProgramController.js";
export declare class PCCProgramAnalysisVisitor extends PC.AbstractVisitor<void> {
    readonly programController: PCCProgramController;
    constructor(programController: PCCProgramController);
    visitProgram(node: PC.Program, context?: unknown): void;
    visitMainAgent(node: PC.MainAgent, context?: unknown): void;
    visitProcedureDeclaration(node: PC.ProcedureDeclaration, context?: unknown): void;
    visitMonitor(node: PC.Monitor, context?: unknown): void;
    visitStruct(node: PC.Struct, context?: unknown): void;
    visitConditionDeclaration(node: PC.ConditionDeclaration, context?: unknown): void;
    visitVariableDeclarations(node: PC.VariableDeclarations, context?: unknown): void;
    visitVariableDeclarator(node: PC.VariableDeclarator, context?: unknown): void;
    visitStatementWrapper(node: PC.StatementWrapper, context?: unknown): void;
    visitBreakStatement(node: PC.BreakStatement, context?: unknown): void;
    visitContinueStatement(node: PC.ContinueStatement, context?: unknown): void;
    visitStatementBlock(node: PC.StatementBlock, context?: unknown): void;
    visitStatementExpression(node: PC.StatementExpression, context?: unknown): void;
    visitSelectStatement(node: PC.SelectStatement, context?: unknown): void;
    visitCase(node: PC.Case, context?: unknown): void;
    visitIfStatement(node: PC.IfStatement, context?: unknown): void;
    visitWhileStatement(node: PC.WhileStatement, context?: unknown): void;
    visitDoStatement(node: PC.DoStatement, context?: unknown): void;
    visitForStatement(node: PC.ForStatement, context?: unknown): void;
    visitForInit(node: PC.ForInit, context?: unknown): void;
    visitReturnStatement(node: PC.ReturnStatement, context?: unknown): void;
    visitPrimitiveStatement(node: PC.PrimitiveStatement, context?: unknown): void;
    visitPrintStatement(node: PC.PrintStatement, context?: unknown): void;
    visitConditionStatement(node: PC.ConditionStatement, context?: unknown): void;
    visitProcedureParameter(node: PC.ProcedureParameter, context?: unknown): void;
    visitVariableInitializer(node: PC.VariableInitializer, context?: unknown): void;
    visitArrayTypeNode(node: PC.ArrayTypeNode, context?: unknown): void;
    visitSimpleTypeNode(node: PC.SimpleTypeNode, context?: unknown): void;
    visitChannelTypeNode(node: PC.ChannelTypeNode, context?: unknown): void;
    visitClassTypeNode(node: PC.ClassTypeNode, context?: unknown): void;
    visitStartExpression(node: PC.StartExpression, context?: unknown): void;
    visitAssignExpression(node: PC.AssignExpression, context?: unknown): void;
    visitAssignDestination(node: PC.AssignDestination, context?: unknown): void;
    visitSendExpression(node: PC.SendExpression, context?: unknown): void;
    visitConditionalExpression(node: PC.ConditionalExpression, context?: unknown): void;
    visitOrExpression(node: PC.OrExpression, context?: unknown): void;
    visitAndExpression(node: PC.AndExpression, context?: unknown): void;
    visitEqualityExpression(node: PC.EqualityExpression, context?: unknown): void;
    visitRelationalExpression(node: PC.RelationalExpression, context?: unknown): void;
    visitAdditiveExpression(node: PC.AdditiveExpression, context?: unknown): void;
    visitMultiplicativeExpression(node: PC.MultiplicativeExpression, context?: unknown): void;
    visitUnaryExpression(node: PC.UnaryExpression, context?: unknown): void;
    visitPostfixExpression(node: PC.PostfixExpression, context?: unknown): void;
    visitReceiveExpression(node: PC.ReceiveExpression, context?: unknown): void;
    visitProcedureCall(node: PC.ProcedureCall, context?: unknown): void;
    visitClassCall(node: PC.ClassCall, context?: unknown): void;
    visitArrayExpression(node: PC.ArrayExpression, context?: unknown): void;
    visitLiteralExpression(node: PC.LiteralExpression, context?: unknown): void;
    visitIdentifierExpression(node: PC.IdentifierExpression, context?: unknown): void;
}
